Icicle from Drilldown in JavaScript

Using ApexCharts with JavaScript

This Icicle from Drilldown example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// An icicle reads the SAME `series` + `drilldown.series` config a drilldown
// chart uses, so an existing drilldown chart becomes an icicle by flipping
// `chart.type`. It reads that config as plain data: the drilldown feature
// itself is never loaded here.
var channelColors = ['#0EA5E9', '#14B8A6', '#F59E0B']
var searchColors = ['#0369A1', '#0284C7', '#38BDF8']
var socialColors = ['#0F766E', '#14B8A6', '#5EEAD4']

var options = {
  series: [
    {
      data: [
        { x: 'Search', y: 790, drilldown: 'search' },
        { x: 'Social', y: 360, drilldown: 'social' },
        { x: 'Direct', y: 240 },
      ],
    },
  ],
  chart: {
    type: 'icicle',
    height: 380,
  },
  colors: channelColors,
  // A legend is off by default (every cell is labelled already), but this tree
  // has several roots, so the palette lines up with it exactly.
  legend: {
    show: true,
    position: 'bottom',
  },
  title: {
    text: 'Signups by acquisition channel',
    align: 'left',
  },
  subtitle: {
    text: 'The same series + drilldown.series config as a drilldown chart, shown whole.',
    align: 'left',
  },
  plotOptions: {
    icicle: {
      direction: 'right',
      borderRadius: 2,
    },
  },
  stroke: {
    width: 1,
    colors: ['#fff'],
  },
  drilldown: {
    series: [
      {
        id: 'search',
        name: 'Search',
        colors: searchColors,
        data: [
          { x: 'Organic', y: 420 },
          { x: 'Paid', y: 260 },
          { x: 'Brand', y: 110 },
        ],
      },
      {
        id: 'social',
        name: 'Social',
        colors: socialColors,
        data: [
          { x: 'Video', y: 180 },
          { x: 'Posts', y: 120 },
          { x: 'Communities', y: 60 },
        ],
      },
    ],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Icicle from Drilldown in React

Using ApexCharts with React

This Icicle from Drilldown example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/icicle'

// An icicle reads the SAME `series` + `drilldown.series` config a drilldown
// chart uses, so an existing drilldown chart becomes an icicle by flipping
// `chart.type`. It reads that config as plain data: the drilldown feature
// itself is never loaded here.
var channelColors = ['#0EA5E9', '#14B8A6', '#F59E0B']
var searchColors = ['#0369A1', '#0284C7', '#38BDF8']
var socialColors = ['#0F766E', '#14B8A6', '#5EEAD4']

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        data: [
          { x: 'Search', y: 790, drilldown: 'search' },
          { x: 'Social', y: 360, drilldown: 'social' },
          { x: 'Direct', y: 240 },
        ],
      },
    ],
    options: {
      chart: {
        type: 'icicle',
        height: 380,
      },
      colors: channelColors,
      // A legend is off by default (every cell is labelled already), but this tree
      // has several roots, so the palette lines up with it exactly.
      legend: {
        show: true,
        position: 'bottom',
      },
      title: {
        text: 'Signups by acquisition channel',
        align: 'left',
      },
      subtitle: {
        text: 'The same series + drilldown.series config as a drilldown chart, shown whole.',
        align: 'left',
      },
      plotOptions: {
        icicle: {
          direction: 'right',
          borderRadius: 2,
        },
      },
      stroke: {
        width: 1,
        colors: ['#fff'],
      },
      drilldown: {
        series: [
          {
            id: 'search',
            name: 'Search',
            colors: searchColors,
            data: [
              { x: 'Organic', y: 420 },
              { x: 'Paid', y: 260 },
              { x: 'Brand', y: 110 },
            ],
          },
          {
            id: 'social',
            name: 'Social',
            colors: socialColors,
            data: [
              { x: 'Video', y: 180 },
              { x: 'Posts', y: 120 },
              { x: 'Communities', y: 60 },
            ],
          },
        ],
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="icicle"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart

Icicle from Drilldown in Angular

Using ApexCharts with Angular

This Icicle from Drilldown example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private channelColors: any = ['#0EA5E9', '#14B8A6', '#F59E0B'];

  private searchColors: any = ['#0369A1', '#0284C7', '#38BDF8'];

  private socialColors: any = ['#0F766E', '#14B8A6', '#5EEAD4'];

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              data: [
                { x: 'Search', y: 790, drilldown: 'search' },
                { x: 'Social', y: 360, drilldown: 'social' },
                { x: 'Direct', y: 240 },
              ],
            },
          ],
          chart: {
            type: 'icicle',
            height: 380,
          },
          colors: this.channelColors,
          // A legend is off by default (every cell is labelled already), but this tree
          // has several roots, so the palette lines up with it exactly.
          legend: {
            show: true,
            position: 'bottom',
          },
          title: {
            text: 'Signups by acquisition channel',
            align: 'left',
          },
          subtitle: {
            text: 'The same series + drilldown.series config as a drilldown chart, shown whole.',
            align: 'left',
          },
          plotOptions: {
            icicle: {
              direction: 'right',
              borderRadius: 2,
            },
          },
          stroke: {
            width: 1,
            colors: ['#fff'],
          },
          drilldown: {
            series: [
              {
                id: 'search',
                name: 'Search',
                colors: this.searchColors,
                data: [
                  { x: 'Organic', y: 420 },
                  { x: 'Paid', y: 260 },
                  { x: 'Brand', y: 110 },
                ],
              },
              {
                id: 'social',
                name: 'Social',
                colors: this.socialColors,
                data: [
                  { x: 'Video', y: 180 },
                  { x: 'Posts', y: 120 },
                  { x: 'Communities', y: 60 },
                ],
              },
            ],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Icicle from Drilldown in Vue

Using ApexCharts with Vue

This Icicle from Drilldown example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="icicle"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/icicle'

// An icicle reads the SAME `series` + `drilldown.series` config a drilldown
// chart uses, so an existing drilldown chart becomes an icicle by flipping
// `chart.type`. It reads that config as plain data: the drilldown feature
// itself is never loaded here.
var channelColors = ['#0EA5E9', '#14B8A6', '#F59E0B']
var searchColors = ['#0369A1', '#0284C7', '#38BDF8']
var socialColors = ['#0F766E', '#14B8A6', '#5EEAD4']

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          data: [
            { x: 'Search', y: 790, drilldown: 'search' },
            { x: 'Social', y: 360, drilldown: 'social' },
            { x: 'Direct', y: 240 },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'icicle',
          height: 380,
        },
        colors: channelColors,
        // A legend is off by default (every cell is labelled already), but this tree
        // has several roots, so the palette lines up with it exactly.
        legend: {
          show: true,
          position: 'bottom',
        },
        title: {
          text: 'Signups by acquisition channel',
          align: 'left',
        },
        subtitle: {
          text: 'The same series + drilldown.series config as a drilldown chart, shown whole.',
          align: 'left',
        },
        plotOptions: {
          icicle: {
            direction: 'right',
            borderRadius: 2,
          },
        },
        stroke: {
          width: 1,
          colors: ['#fff'],
        },
        drilldown: {
          series: [
            {
              id: 'search',
              name: 'Search',
              colors: searchColors,
              data: [
                { x: 'Organic', y: 420 },
                { x: 'Paid', y: 260 },
                { x: 'Brand', y: 110 },
              ],
            },
            {
              id: 'social',
              name: 'Social',
              colors: socialColors,
              data: [
                { x: 'Video', y: 180 },
                { x: 'Posts', y: 120 },
                { x: 'Communities', y: 60 },
              ],
            },
          ],
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 760px;
  margin: 35px auto;
}
</style>